import matplotlib.image as mpimg # On charge la bibliothèque matplotlib.image
import matplotlib.pyplot as plt # On charge la bibliothèque matplotlib.pyplot
import numpy as np # On charge la bibliothèque numpy

image = mpimg.imread("Images/Trouver ligne blanche 6.png") # On lit le fichier Paysage 1.png situé dans le dossier Images

if image.dtype == np.float32: # Si le résultat n'est pas un tableau d'entiers
    image = (image * 255).astype(np.uint8) # On effectue une conversion des données

tailleImage = image.size # Taille de l'image : données utiles en octets
nombreLignes = image.shape[0] # nombre de lignes
nombreColonnes = image.shape[1] # nombre de colonnes

print(tailleImage) # On affiche la taille de l'image
print(nombreLignes) # On affiche le nombre de lignes
print(nombreColonnes) # On affiche le nombre de colonnes

imageTraitee = np.copy(image) # On fait une copie de l'image originale

N = 10
x0 = 0

while(x0 < nombreLignes):
    # On parcourt la première ligne
    xA = x0+0 # position de la première ligne dans le repère de l'image
    i = xA # première ligne : ligne n°0
    # On cherche le maximum
    maximum = 0
    for j in range(imageTraitee.shape[1]): # On parcours les colonnes de la première ligne
        r, v, b, n = image[i, j] # On extrait les composantes R V B du pixel
        intensitePixel = ((r**2 + v**2 + b**2)**0.5)/(3**0.5)
        if(intensitePixel > maximum):
            maximum = intensitePixel
    seuil = 0.9*maximum


    num = 0
    den = 0
    for j in range(imageTraitee.shape[1]): # On parcours les colonnes de la première ligne
        r, v, b, n = image[i, j] # On extrait les composantes R V B du pixel
        intensitePixel = ((r**2 + v**2 + b**2)**0.5)/(3**0.5)
        # print(intensitePixel)
        if(intensitePixel > seuil): # On a trouvé un pixel blanc (la ligne blanche)
            imageTraitee[i, j]=(255,255,0,255)
            num = num+j # On fait la somme des positions (n° de colonnes) des pixels blancs de la première ligne
            den = den+1 # nombre de pixels blancs sur la première ligne
    print(num)
    print(den)
    yA = num/den # Position moyenne des pixels blancs sur la première ligne


    # On parcourt la dernière ligne
    xB = int(x0+nombreLignes/N) # position de la dernière ligne dans le repère de l'image
    if(xB >= nombreLignes):
        xB = nombreLignes-1
    i = xB # dernière ligne : ligne n°(nombreLignes-1) car on part de 0
    # On cherche le maximum
    maximum = 0
    for j in range(imageTraitee.shape[1]): # On parcours les colonnes de la première ligne
        r, v, b, n = image[i, j] # On extrait les composantes R V B du pixel
        intensitePixel = ((r**2 + v**2 + b**2)**0.5)/(3**0.5)
        if(intensitePixel > maximum):
            maximum = intensitePixel
    seuil = 0.9*maximum


    num = 0
    den = 0
    for j in range(imageTraitee.shape[1]): # On parcours les colonnes de la dernière ligne
        r, v, b, n = image[i, j] # On extrait les composantes R V B du pixel
        intensitePixel = ((r**2 + v**2 + b**2)**0.5)/(3**0.5)
        if(intensitePixel > seuil): # On a trouvé un pixel blanc (la ligne blanche)
            imageTraitee[i, j]=(255,255,0,255)
            num = num+j # On fait la somme des positions (n° de colonnes) des pixels blancs de la dernière ligne
            den = den+1 # nombre de pixels blancs sur la dernière ligne
    yB = num/den # Position moyenne des pixels blancs sur la dernière ligne


    # Dans le repère de l'image, on a deux point :
    # APrem (xPrem ; yPrem)
    # ADern (xDern ; yDern)

    # Dans le repère de l'image, on va déterminer l'équation réduire de la droite (APrem Adern)
    # On vérifie d'abors que xDern est différent de xPrem sinon la droite est verticale !
    # On calcule d'abord le coefficient directeur m = (yDern - yPrem) / (xDern - xPrem)
    # Puis on calcule l'ordonnée à l'origine p = yPrem - m * xPrem

    if(xB != xA):
        m = (yB - yA) / (xB - xA)
        p = yA - m * xA
        print("l'équation réduite de la ligne blanche est : y = ",m," x + ",p)
    else:
        print("La ligne blanche est verticale dans le repère de l'image !")
        print("Son équation réduite est x = ",xA)

    # On trace la ligne blanche "vue" par le programme Python en bleu
    # On ne traite pas le cas où la ligne blanche est verticale dans le repère de l'image
    for i in range(x0,min(nombreLignes , int(x0+nombreLignes/N) )): # On parcours les lignes : x
        x=i
        y = m*x+p
        j = int(y) # y peut être un nombre à virgule, on arrondit à l'entier le plus proche
        imageTraitee[i, j]=(0,0,255,255) # On trace un pixel bleu

    x0 = int(x0+nombreLignes/N)

plt.imshow(imageTraitee) # On affiche l'image traitée
plt.show()

mpimg.imsave("Images/imageTraitee 2.png", imageTraitee) # On sauvegarde l'image traitée